%bcond_without fip
%bcond_without wx

Summary:	General-purpose programming language and runtime environment
Name:		erlang
Version:	25.3
Release:    2%{?dist}
License:	ASL 2.0
URL:		https://www.erlang.org
VCS:		scm:git:https://github.com/erlang/otp
Source0:	https://github.com/erlang/otp/archive/OTP-%{version}/otp-OTP-%{version}.tar.gz
Source5:	epmd.service
Source6:	epmd.socket
Source7:	epmd@.service
Source8:	epmd@.socket

Patch3000: otp-0001-Do-not-format-man-pages-and-do-not-install-miscellan.patch
Patch3001: otp-0002-Remove-rpath.patch
Patch3002: otp-0003-Do-not-install-C-sources.patch
Patch3003: otp-0004-Do-not-install-Java-sources.patch
Patch3004: otp-0005-Do-not-install-nteventlog-and-related-doc-files-on-n.patch
Patch3005: otp-0006-Do-not-install-erlang-sources.patch
Patch3006: otp-0007-Add-extra-search-directory.patch
Patch3007: otp-0008-Avoid-forking-sed-to-get-basename.patch
Patch3008: otp-0009-Load-man-pages-from-system-wide-directory.patch
Patch3009: otp-0010-configure.ac-C99-fix-for-ERTS___AFTER_MORECORE_HOOK_.patch
Patch3010: otp-0011-configure.ac-C99-fixes-for-poll_works-check.patch
Patch3011: otp-0012-Revert-Do-not-install-erlang-sources.patch

BuildRequires:	gcc gcc-c++ autoconf automake make
BuildRequires:  flex systemd-devel systemd

%{?systemd_requires}
Requires:	systemd

Requires: %{name}-asn1 = %{version}-%{release}
Requires: %{name}-common_test = %{version}-%{release}
Requires: %{name}-compiler = %{version}-%{release}
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-debugger = %{version}-%{release}
Requires: %{name}-dialyzer = %{version}-%{release}
Requires: %{name}-diameter = %{version}-%{release}
Requires: %{name}-edoc = %{version}-%{release}
Requires: %{name}-eldap = %{version}-%{release}
Requires: %{name}-erl_docgen = %{version}-%{release}
Requires: %{name}-erl_interface = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-et = %{version}-%{release}
Requires: %{name}-eunit = %{version}-%{release}
Requires: %{name}-ftp = %{version}-%{release}
Requires: %{name}-inets = %{version}-%{release}
Requires: %{name}-jinterface = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-megaco = %{version}-%{release}
Requires: %{name}-mnesia = %{version}-%{release}
Requires: %{name}-observer = %{version}-%{release}
Requires: %{name}-odbc = %{version}-%{release}
Requires: %{name}-os_mon = %{version}-%{release}
Requires: %{name}-parsetools = %{version}-%{release}
Requires: %{name}-public_key = %{version}-%{release}
Requires: %{name}-reltool = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-sasl = %{version}-%{release}
Requires: %{name}-snmp = %{version}-%{release}
Requires: %{name}-ssh = %{version}-%{release}
Requires: %{name}-ssl = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-syntax_tools = %{version}-%{release}
Requires: %{name}-tftp = %{version}-%{release}
Requires: %{name}-tools = %{version}-%{release}
%if %{with wx}
Requires: %{name}-wx = %{version}-%{release}
%endif
Requires: %{name}-xmerl = %{version}-%{release}

%description
Erlang is a general-purpose programming language and runtime
environment. Erlang has built-in support for concurrency, distribution
and fault tolerance. Erlang is used in several large telecommunication
systems from Ericsson.


%package asn1
Summary: Provides support for Abstract Syntax Notation One
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description asn1
Provides support for Abstract Syntax Notation One.

%package common_test
Summary: A portable framework for automatic testing
Requires: %{name}-compiler = %{version}-%{release}
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-debugger = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-inets = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-observer = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-sasl = %{version}-%{release}
Requires: %{name}-snmp = %{version}-%{release}
Requires: %{name}-ssh = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-syntax_tools = %{version}-%{release}
Requires: %{name}-tools = %{version}-%{release}
Requires: %{name}-xmerl = %{version}-%{release}

%description common_test
A portable framework for automatic testing.

%package compiler
Summary: A byte code compiler for Erlang which produces highly compact code
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description compiler
A byte code compiler for Erlang which produces highly compact code.

%package crypto
Summary: Cryptographical support
BuildRequires: pkgconfig(openssl)
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description crypto
Cryptographical support.

%package debugger
Summary: A debugger for debugging and testing of Erlang programs
Requires: %{name}-compiler = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-wx = %{version}-%{release}

%description debugger
A debugger for debugging and testing of Erlang programs.

%package dialyzer
Summary: A DIscrepancy AnaLYZer for ERlang programs
Requires: %{name}-compiler = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-syntax_tools = %{version}-%{release}
%if %{with wx}
Requires: %{name}-wx = %{version}-%{release}
%endif
Requires: graphviz

%description dialyzer
A DIscrepancy AnaLYZer for ERlang programs.

%package diameter
Summary: Diameter (RFC 3588) library
BuildRequires: ed
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-ssl = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-syntax_tools = %{version}-%{release}

%description diameter
Diameter (RFC 3588) library

%package edoc
Summary: A utility used to generate documentation out of tags in source files
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-inets = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-syntax_tools = %{version}-%{release}
Requires: %{name}-xmerl = %{version}-%{release}

%description edoc
A utility used to generate documentation out of tags in source files.

%package eldap
Summary: Erlang LDAP library
Requires: %{name}-asn1 = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-ssl = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description eldap
Erlang LDAP library.

%package erl_docgen
Summary: A utility used to generate erlang HTML documentation
Requires: %{name}-edoc = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-xmerl = %{version}-%{release}

%description erl_docgen
A utility used to generate erlang HTML documentation.

%package erl_interface
Summary: Low level interface to C
Requires: %{name}-erts = %{version}-%{release}

%description erl_interface
Low level interface to C.

%package erts
Summary: Functionality necessary to run the Erlang System itself
BuildRequires: lksctp-tools-devel
BuildRequires: m4
BuildRequires: ncurses-devel
BuildRequires: zlib-devel
Requires(pre): shadow-utils
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: lksctp-tools
Provides: erlang(erl_drv_version) = 3.3
Provides: erlang(erl_nif_version) = 2.15
Provides: bundled(pcre) = 8.33

%description erts
Functionality necessary to run the Erlang System itself.

%package et
Summary: An event tracer for Erlang programs
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
%if %{with wx}
Requires: %{name}-wx = %{version}-%{release}
%endif

%description et
An event tracer for Erlang programs.

%package eunit
Summary: Support for unit testing
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description eunit
Support for unit testing.

%package examples
Summary: Examples for some Erlang modules
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-public_key = %{version}-%{release}
Requires: %{name}-sasl = %{version}-%{release}
Requires: %{name}-ssl = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description examples
Examples for some Erlang modules.

%package ftp
Summary: FTP client
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description ftp
FTP client.

%package inets
Summary: A set of services such as a Web server and a HTTP client etc
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-mnesia = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-ssl = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description inets
A set of services such as a Web server and a HTTP client etc.

%package jinterface
Summary: A library for accessing Java from Erlang
BuildRequires: java-devel
Requires: javapackages-tools
Requires: %{name}-erts = %{version}-%{release}

%description jinterface
Low level interface to Java.

%package kernel
Summary: Main erlang library
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description kernel
Main erlang library.

%package megaco
Summary: Megaco/H.248 support library
Requires: %{name}-asn1 = %{version}-%{release}
Requires: %{name}-debugger = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-et = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description megaco
Megaco/H.248 is a protocol for control of elements in a physically
decomposed multimedia gateway, enabling separation of call control
from media conversion.

%package mnesia
Summary: A heavy duty real-time distributed database
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description mnesia
A heavy duty real-time distributed database.

%package observer
Summary: A set of tools for tracing and investigation of distributed systems
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-et = %{version}-%{release}
Requires: %{name}-inets = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
%if %{with wx}
Requires: %{name}-wx = %{version}-%{release}
%endif

%description observer
A set of tools for tracing and investigation of distributed systems.

%package odbc
Summary: A library for unixODBC support in Erlang
BuildRequires: unixODBC-devel
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description odbc
An interface to relational SQL-databases built on ODBC (Open Database
Connectivity).

%package os_mon
Summary: A monitor which allows inspection of the underlying operating system
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-mnesia = %{version}-%{release}
Requires: %{name}-sasl = %{version}-%{release}
Requires: %{name}-snmp = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description os_mon
A monitor which allows inspection of the underlying operating system.

%package parsetools
Summary: A set of parsing and lexical analysis tools
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description parsetools
A set of parsing and lexical analysis tools.

%package public_key
Summary: API to public key infrastructure
Requires: %{name}-asn1 = %{version}-%{release}
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description public_key
API to public key infrastructure.

%package reltool
Summary: A release management tool
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-sasl = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-tools = %{version}-%{release}
%if %{with wx}
Requires: %{name}-wx = %{version}-%{release}
%endif

%description reltool
Reltool is a release management tool. It analyses a given
Erlang/OTP installation and determines various dependencies
between applications. The graphical frontend depicts the
dependencies and enables interactive customization of a
target system. The backend provides a batch interface
for generation of customized target systems.

%package runtime_tools
Summary: A set of tools to include in a production system
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-mnesia = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description runtime_tools
A set of tools to include in a production system.

%package sasl
Summary: The System Architecture Support Libraries
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: %{name}-tools = %{version}-%{release}

%description sasl
The System Architecture Support Libraries is a set of tools for
release upgrades and alarm handling etc.

%package snmp
Summary: Simple Network Management Protocol (SNMP) support
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-mnesia = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description snmp
Simple Network Management Protocol (SNMP) support including a
MIB compiler and tools for creating SNMP agents.

%package ssh
Summary: Secure Shell application with sftp and ssh support
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-public_key = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description ssh
Secure Shell application with sftp and ssh support.

%package ssl
Summary: Secure Socket Layer support
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-inets = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-public_key = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description ssl
Secure Socket Layer support.

%package stdlib
Summary: The Erlang standard libraries
Requires: %{name}-compiler = %{version}-%{release}
Requires: %{name}-crypto = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}

%description stdlib
The Erlang standard libraries.

%package syntax_tools
Summary: A set of tools for dealing with erlang sources
Requires: %{name}-compiler = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description syntax_tools
A utility used to handle abstract Erlang syntax trees,
reading source files differently, pretty-printing syntax trees.

%package tftp
Summary: TFTP client
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description tftp
TFTP client.

%package tools
Summary: A set of programming tools including a coverage analyzer etc
BuildRequires: emacs
BuildRequires: emacs-el
Requires: %{name}-compiler = %{version}-%{release}
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-inets = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-runtime_tools = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: emacs-filesystem


%description tools
A set of programming tools including a coverage analyzer etc.

%if %{with wx}
%package wx
Summary: A library for wxWidgets support in Erlang
BuildRequires: wxGTK3-devel
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}
Requires: mesa-libGL
Requires: mesa-libGLU

%description wx
A Graphics System used to write platform independent user interfaces.
%endif

%package xmerl
Summary: Provides support for XML 1.0
Requires: %{name}-erts = %{version}-%{release}
Requires: %{name}-kernel = %{version}-%{release}
Requires: %{name}-stdlib = %{version}-%{release}

%description xmerl
Provides support for XML 1.0.

%prep
%autosetup -p1 -n otp-OTP-%{version}


%build
./otp_build autoconf

ERL_FLAGS="${RPM_OPT_FLAGS} -fno-strict-aliasing"

CFLAGS="${ERL_FLAGS}"
CXXFLAGS="${ERL_FLAGS}"
%configure \
    --enable-shared-zlib \
    --enable-sctp \
    --enable-systemd \
    --disable-silent-rules \
    %{?with_fips:--enable-fips} \
	--with-wx-config=/usr/bin/wx-config-3.0

make clean

erlang_tools_vsn="$(sed -n 's/TOOLS_VSN = //p' lib/tools/vsn.mk)"

cat > emacs-erlang-init.el << EOF
(setq load-path (cons "%{_emacs_sitelispdir}/erlang" load-path))
(setq erlang-root-dir "%{_libdir}/erlang")
(setq exec-path (cons "%{_libdir}/erlang/bin" exec-path))
(require 'erlang-start)
EOF
mkdir emacs-erlang
cp lib/tools/emacs/*.el emacs-erlang/
pushd emacs-erlang
%{_emacs_bytecompile} *.el
popd

make

%install
erlang_tools_vsn="$(sed -n 's/TOOLS_VSN = //p' lib/tools/vsn.mk)"

install -m 0755 -d "%{buildroot}%{_emacs_sitestartdir}"
install -m 0755 -d "%{buildroot}%{_emacs_sitelispdir}/erlang"
install -m 0644 emacs-erlang-init.el "%{buildroot}%{_emacs_sitestartdir}/erlang-init.el"
for f in lib/tools/emacs/{README,*.el}; do
	b="$(basename "$f")";
	ln -s "%{_libdir}/erlang/lib/tools-${erlang_tools_vsn}/emacs/$b" \
		"%{buildroot}%{_emacs_sitelispdir}/erlang/"
done
install -m 0644 emacs-erlang/*.elc "%{buildroot}%{_emacs_sitelispdir}/erlang/"

%make_install

find %{buildroot}%{_libdir}/erlang -type f -name info -exec rm -f {} \;
find %{buildroot}%{_libdir}/erlang/lib/ssl-*/examples/ -type d -perm 0775 -print -exec chmod 755 {} \;
find %{buildroot}%{_libdir}/erlang/lib/kernel-*/examples/uds_dist -type d -perm 0775 -print -exec chmod 755 {} \;

chmod 0755 %{buildroot}%{_libdir}/erlang/bin

rm -f %{buildroot}%{_libdir}/erlang/man/man1/erlsrv.*
rm -f %{buildroot}%{_libdir}/erlang/man/man1/werl.*
rm -f %{buildroot}%{_libdir}/erlang/man/man3/win32reg.*
rm -r %{buildroot}%{_libdir}/erlang/erts-*/man
rm -f %{buildroot}%{_libdir}/erlang/Install

for exe in %{buildroot}%{_libdir}/erlang/erts-*/bin/*
do
	base="$(basename "$exe")"
	next="%{buildroot}%{_libdir}/erlang/bin/${base}"
	rel="$(echo "$exe" | sed "s,^%{buildroot}%{_libdir}/erlang/,../,")"
	if cmp "$exe" "$next"; then
		ln -sf "$rel" "$next"
	fi
done
for exe in %{buildroot}%{_libdir}/erlang/bin/*
do
	base="$(basename "$exe")"
	next="%{buildroot}%{_bindir}/${base}"
	rel="$(echo "$exe" | sed "s,^%{buildroot},,")"
	if cmp "$exe" "$next"; then
		ln -sf "$rel" "$next"
	fi
done

install -m 0755 -d "%{buildroot}%{_javadir}/%{name}"

jinterface_lib_dir="$(ls -d1 %{buildroot}%{_libdir}/erlang/lib/jinterface-*/ | sed "s,^%{buildroot},,")"
test -d "%{buildroot}$jinterface_lib_dir"
ln -s "${jinterface_lib_dir}priv/OtpErlang.jar" "%{buildroot}%{_javadir}/%{name}/"

install -D -p -m 0644 %{SOURCE5} %{buildroot}%{_unitdir}/epmd.service
install -D -p -m 0644 %{SOURCE6} %{buildroot}%{_unitdir}/epmd.socket
install -D -p -m 0644 %{SOURCE7} %{buildroot}%{_unitdir}/epmd@.service
install -D -p -m 0644 %{SOURCE8} %{buildroot}%{_unitdir}/epmd@.socket
install -d -p -m 0755 %{buildroot}%{_datadir}/erlang/
install -d -p -m 0755 %{buildroot}%{_datadir}/erlang/lib

%if %{without wx}
rm -rf %{buildroot}%{_libdir}/erlang/lib/wx-*/
%endif

%check
TARGET="$(make target_configured)"
ERL_TOP="$(pwd)"
ERL_TOP=${ERL_TOP} make TARGET=${TARGET} release_tests


%pre erts
getent group epmd >/dev/null || groupadd -r epmd
getent passwd epmd >/dev/null || \
useradd -r -g epmd -d /dev/null -s /sbin/nologin \
-c "Erlang Port Mapper Daemon" epmd 2>/dev/null || :


%files

%files asn1
%dir %{_libdir}/erlang/lib/asn1-*/
%{_libdir}/erlang/lib/asn1-*/ebin
%{_libdir}/erlang/lib/asn1-*/priv
%{_libdir}/erlang/lib/asn1-*/src

%files common_test
%{_bindir}/ct_run
%{_libdir}/erlang/bin/ct_run
%{_libdir}/erlang/erts-*/bin/ct_run
%{_libdir}/erlang/lib/common_test-*/

%files compiler
%{_libdir}/erlang/lib/compiler-*/

%files crypto
%{_libdir}/erlang/lib/crypto-*/

%files debugger
%{_libdir}/erlang/lib/debugger-*/

%files dialyzer
%{_bindir}/dialyzer
%{_bindir}/typer
%{_libdir}/erlang/bin/dialyzer
%{_libdir}/erlang/bin/typer
%{_libdir}/erlang/erts-*/bin/dialyzer
%{_libdir}/erlang/erts-*/bin/typer
%{_libdir}/erlang/lib/dialyzer-*/

%files diameter
%dir %{_libdir}/erlang/lib/diameter-*/
%{_libdir}/erlang/lib/diameter-*/bin
%{_libdir}/erlang/lib/diameter-*/ebin
%{_libdir}/erlang/lib/diameter-*/include
%{_libdir}/erlang/lib/diameter-*/src

%files edoc
%{_libdir}/erlang/lib/edoc-*/

%files eldap
%{_libdir}/erlang/lib/eldap-*/

%files erl_docgen
%{_libdir}/erlang/lib/erl_docgen-*/

%files erl_interface
%{_libdir}/erlang/bin/erl_call
%{_libdir}/erlang/erts-*/bin/erl_call
%{_libdir}/erlang/lib/erl_interface-*/

%files erts
%dir %{_datadir}/erlang/
%dir %{_datadir}/erlang/lib/
%dir %{_libdir}/erlang/
%dir %{_libdir}/erlang/bin/
%dir %{_libdir}/erlang/lib/
%dir %{_libdir}/erlang/releases/
%dir %{_libdir}/erlang/erts-*/
%dir %{_libdir}/erlang/erts-*/bin/
%{_bindir}/epmd
%{_bindir}/erl
%{_bindir}/erlc
%{_bindir}/escript
%{_bindir}/run_erl
%{_bindir}/to_erl
%{_libdir}/erlang/bin/epmd
%{_libdir}/erlang/bin/erl
%{_libdir}/erlang/bin/erlc
%{_libdir}/erlang/bin/escript
%{_libdir}/erlang/bin/no_dot_erlang.boot
%{_libdir}/erlang/bin/run_erl
%{_libdir}/erlang/bin/start
%{_libdir}/erlang/bin/start.boot
%{_libdir}/erlang/bin/start.script
%{_libdir}/erlang/bin/start_clean.boot
%{_libdir}/erlang/bin/start_erl
%{_libdir}/erlang/bin/start_sasl.boot
%{_libdir}/erlang/bin/to_erl
%{_libdir}/erlang/erts-*/bin/beam.smp
%{_libdir}/erlang/erts-*/bin/dyn_erl
%{_libdir}/erlang/erts-*/bin/epmd
%{_libdir}/erlang/erts-*/bin/erl
%{_libdir}/erlang/erts-*/bin/erl.src
%{_libdir}/erlang/erts-*/bin/erl_child_setup
%{_libdir}/erlang/erts-*/bin/erlc
%{_libdir}/erlang/erts-*/bin/erlexec
%{_libdir}/erlang/erts-*/bin/escript
%{_libdir}/erlang/erts-*/bin/heart
%{_libdir}/erlang/erts-*/bin/inet_gethost
%{_libdir}/erlang/erts-*/bin/run_erl
%{_libdir}/erlang/erts-*/bin/start
%{_libdir}/erlang/erts-*/bin/start.src
%{_libdir}/erlang/erts-*/bin/start_erl.src
%{_libdir}/erlang/erts-*/bin/to_erl
%{_libdir}/erlang/erts-*/bin/yielding_c_fun
%{_libdir}/erlang/erts-*/include
%{_libdir}/erlang/erts-*/lib/
%{_libdir}/erlang/erts-*/src/
%{_libdir}/erlang/lib/erts-*/
%{_libdir}/erlang/releases/*
%{_libdir}/erlang/usr/
%{_unitdir}/epmd.service
%{_unitdir}/epmd.socket
%{_unitdir}/epmd@.service
%{_unitdir}/epmd@.socket

%files et
%dir %{_libdir}/erlang/lib/et-*/
%{_libdir}/erlang/lib/et-*/ebin
%{_libdir}/erlang/lib/et-*/include
%{_libdir}/erlang/lib/et-*/src

%files eunit
%dir %{_libdir}/erlang/lib/eunit-*/
%{_libdir}/erlang/lib/eunit-*/ebin
%{_libdir}/erlang/lib/eunit-*/include
%{_libdir}/erlang/lib/eunit-*/src

%files examples
%{_libdir}/erlang/lib/asn1-*/examples/
%{_libdir}/erlang/lib/diameter-*/examples/
%{_libdir}/erlang/lib/et-*/examples/
%{_libdir}/erlang/lib/eunit-*/examples/
%{_libdir}/erlang/lib/inets-*/examples/
%{_libdir}/erlang/lib/kernel-*/examples/
%{_libdir}/erlang/lib/megaco-*/examples/
%{_libdir}/erlang/lib/mnesia-*/examples/
%{_libdir}/erlang/lib/observer-*/examples/
%{_libdir}/erlang/lib/reltool-*/examples/
%{_libdir}/erlang/lib/runtime_tools-*/examples/
%{_libdir}/erlang/lib/sasl-*/examples/
%{_libdir}/erlang/lib/snmp-*/examples/
%{_libdir}/erlang/lib/ssl-*/examples/
%{_libdir}/erlang/lib/stdlib-*/examples/
%{_libdir}/erlang/lib/syntax_tools-*/examples/
%{_libdir}/erlang/lib/tools-*/examples/
%if %{with wx}
%{_libdir}/erlang/lib/wx-*/examples/
%endif

%files ftp
%dir %{_libdir}/erlang/lib/ftp-*/
%{_libdir}/erlang/lib/ftp-*/ebin
%{_libdir}/erlang/lib/ftp-*/src

%files inets
%dir %{_libdir}/erlang/lib/inets-*/
%{_libdir}/erlang/lib/inets-*/ebin
%{_libdir}/erlang/lib/inets-*/include
%{_libdir}/erlang/lib/inets-*/priv
%{_libdir}/erlang/lib/inets-*/src

%files jinterface
%dir %{_javadir}/%{name}/
%{_javadir}/%{name}/OtpErlang.jar
%{_libdir}/erlang/lib/jinterface-*/

%files kernel
%dir %{_libdir}/erlang/lib/kernel-*/
%{_libdir}/erlang/lib/kernel-*/ebin
%{_libdir}/erlang/lib/kernel-*/include
%{_libdir}/erlang/lib/kernel-*/src

%files megaco
%dir %{_libdir}/erlang/lib/megaco-*/
%{_libdir}/erlang/lib/megaco-*/ebin
%{_libdir}/erlang/lib/megaco-*/include
%{_libdir}/erlang/lib/megaco-*/priv
%{_libdir}/erlang/lib/megaco-*/src

%files mnesia
%dir %{_libdir}/erlang/lib/mnesia-*/
%{_libdir}/erlang/lib/mnesia-*/ebin
%{_libdir}/erlang/lib/mnesia-*/src

%files observer
%dir %{_libdir}/erlang/lib/observer-*/
%{_libdir}/erlang/lib/observer-*/ebin/
%{_libdir}/erlang/lib/observer-*/include/
%{_libdir}/erlang/lib/observer-*/priv/
%{_libdir}/erlang/lib/observer-*/src/

%files odbc
%{_libdir}/erlang/lib/odbc-*/

%files os_mon
%{_libdir}/erlang/lib/os_mon-*/

%files parsetools
%{_libdir}/erlang/lib/parsetools-*/

%files public_key
%{_libdir}/erlang/lib/public_key-*/

%files reltool
%dir %{_libdir}/erlang/lib/reltool-*/
%{_libdir}/erlang/lib/reltool-*/ebin
%{_libdir}/erlang/lib/reltool-*/src

%files runtime_tools
%dir %{_libdir}/erlang/lib/runtime_tools-*/
%{_libdir}/erlang/lib/runtime_tools-*/ebin/
%{_libdir}/erlang/lib/runtime_tools-*/include/
%{_libdir}/erlang/lib/runtime_tools-*/priv/
%{_libdir}/erlang/lib/runtime_tools-*/src

%files sasl
%dir %{_libdir}/erlang/lib/sasl-*/
%{_libdir}/erlang/lib/sasl-*/ebin
%{_libdir}/erlang/lib/sasl-*/src

%files snmp
%dir %{_libdir}/erlang/lib/snmp-*/
%{_libdir}/erlang/lib/snmp-*/bin
%{_libdir}/erlang/lib/snmp-*/ebin
%{_libdir}/erlang/lib/snmp-*/include
%{_libdir}/erlang/lib/snmp-*/mibs
%{_libdir}/erlang/lib/snmp-*/priv
%{_libdir}/erlang/lib/snmp-*/src

%files ssh
%dir %{_libdir}/erlang/lib/ssh-*/
%{_libdir}/erlang/lib/ssh-*/ebin
%{_libdir}/erlang/lib/ssh-*/include
%{_libdir}/erlang/lib/ssh-*/src

%files ssl
%dir %{_libdir}/erlang/lib/ssl-*/
%{_libdir}/erlang/lib/ssl-*/ebin
%{_libdir}/erlang/lib/ssl-*/src

%files stdlib
%dir %{_libdir}/erlang/lib/stdlib-*/
%{_libdir}/erlang/lib/stdlib-*/ebin
%{_libdir}/erlang/lib/stdlib-*/include
%{_libdir}/erlang/lib/stdlib-*/src

%files syntax_tools
%dir %{_libdir}/erlang/lib/syntax_tools-*/
%{_libdir}/erlang/lib/syntax_tools-*/ebin
%{_libdir}/erlang/lib/syntax_tools-*/include
%{_libdir}/erlang/lib/syntax_tools-*/src

%files tftp
%dir %{_libdir}/erlang/lib/tftp-*/
%{_libdir}/erlang/lib/tftp-*/ebin
%{_libdir}/erlang/lib/tftp-*/src

%files tools
%doc %{_emacs_sitelispdir}/erlang/README
%dir %{_libdir}/erlang/lib/tools-*/
%dir %{_emacs_sitelispdir}/erlang
%{_libdir}/erlang/lib/tools-*/ebin
%{_libdir}/erlang/lib/tools-*/emacs
%{_libdir}/erlang/lib/tools-*/src
%{_libdir}/erlang/lib/tools-*/priv
%{_emacs_sitelispdir}/erlang/*.el
%{_emacs_sitelispdir}/erlang/*.elc
%{_emacs_sitestartdir}/erlang-init.el

%if %{with wx}
%files wx
%dir %{_libdir}/erlang/lib/wx-*/
%{_libdir}/erlang/lib/wx-*/ebin
%{_libdir}/erlang/lib/wx-*/include
%{_libdir}/erlang/lib/wx-*/priv
%{_libdir}/erlang/lib/wx-*/src
%endif

%files xmerl
%{_libdir}/erlang/lib/xmerl-*/


%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 25.3-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 07 2023 cunshunxia <cunshunxia@tencent.com> - 25.3-1
- upgrade to 25.3

* Tue Apr 04 2023 cunshunxia <cunshunxia@tencent.com> - 24.2.2-1
- initial build
